#ifndef ARRAY_H
#define ARRAY_H

/////////////////////////////////////////////////////////////////////////
//
//  array.h : static list of objects  
//  Albert So
//
//  $Header: /usr6/research/code/homebrew/RCS/array.h,v 1.9 1995/10/02 23:07:44 crews Exp $
//
/////////////////////////////////////////////////////////////////////////

#include "object.h"

class Array:public Object{

private:
  Object **list;
  integer  length;

public:
  Array ( integer i);		 //constructor
  Array ( integer i, Object *c);	 //constructor
 ~Array ( void );		//destructor

  integer Count() {return length;}
  void    Put ( integer index, Object *x){ 
    ASSERT( index>=0 && index<length, "out of bounds");
    list [ index ] = x;
  }
  Object *operator[] (integer i);
  void    Resize( integer) { cout << "Not implemented yet\n";}

  virtual void    Print ( ostream& out=cout );
  virtual integer isa() {return ARRAY;}
};

inline ostream& operator << (ostream &out, Array& f)
{ f.Print(out); return out; }

inline ostream& operator << (ostream &out, Array* f)
{ out << "(ptr->)"; f->Print(out); return out; }

#define Array_ForEach_Object(x, o) \
        { \
	  Object *o; \
	  for ( integer i=0; i<x.Count(); i++) { \
	    o = x[ i];

#define Array_ForEach_Type(x, t, o) \
        { \
	  t *o; \
	  for ( integer i=0; i<x.Count(); i++) { \
	    o = (t*) x[ i];


#define Array_End_ForEach }}

#endif // array.h


