//
// bddtest.C
//

#include <stdlib.h>
#include "bdd.h"

int
main (int argc, char *argv[] ) {

  BDDmanager      *bdd;
  BDDnode         *a, *b, *c, *d, *e, *f, *g;
  BDDnode         *y0, *y1, *y2, *y3, *y4;
  BDDsubstitution *f0, *f1, *f2, *f3, *f4;

  bdd = new BDDmanager;

  a  = bdd->Input(0);
  b  = bdd->Input(1);
  c  = bdd->Input(2);
  d  = bdd->Input(3);
  y0 = bdd->Input(4);
  y1 = bdd->Input(5);
  y2 = bdd->Input(6);
  y3 = bdd->Input(7);
  y4 = bdd->Input(8);

  e  = bdd->or(a, b);
  f  = bdd->and(a, b);

  List *F = new List; 

  f0 = new BDDsubstitution(a, y0);  F->Add(*f0);
  f1 = new BDDsubstitution(b, y1);  F->Add(*f1);
  f2 = new BDDsubstitution(e, y2);  F->Add(*f2);
  f3 = new BDDsubstitution(f, y3);  F->Add(*f3);
  f4 = new BDDsubstitution(bdd->or(c,f), y4);  F->Add(*f4);

  cout << bdd->PathsInFunction(a) << endl;  
  bdd->PrintCubes(a);
  cout << bdd->PathsInFunction(b) << endl;  
  bdd->PrintCubes(b);
  cout << bdd->PathsInFunction(e) << endl;  
  bdd->PrintCubes(e);
  cout << bdd->PathsInFunction(f) << endl;  
  bdd->PrintCubes(f);
  cout << bdd->PathsInFunction(bdd->or(c,f)) << endl;  
  bdd->PrintCubes(bdd->or(c,f));

  cout << "\nThe range of the above functions is:\n";

  g = bdd->Range(F);
  bdd->PrintCubes(g);

  bdd->Dump();
  bdd->Print();
}
