#include <strstream.h>
#include "dg.h"

const char ascii_graph1[] = "7 9  1 3  0 2  0 3  3 2  3 4  3 6  2 6  4 5  6 5";

int main() {

  dg graph;

  istrstream in( ascii_graph1 );
  graph.Read( in );

  graph.Print();

  ASSERT( graph.isAcyclic() == TRUE, "Acyclic test failed" );

  cout << "Acyclic test passed: graph is acyclic.\n";

  List *l = graph.TopologicalSortNodes();

  dg_node *nodes[7];
  List_ForEach_Type( l, dg_node, node ) {
    cout << node->GetNum() << ", ";
    nodes[node->GetNum()] = node;
    }List_End_ForEach
  
  cout << endl;
  delete l;

  // now add a cycle

  graph.AddEdge(nodes[5], nodes[4], new dg_edge);

  ASSERT( graph.isAcyclic() == FALSE, "Acyclic test failed" );
  cout << "Acyclic test passed: graph is cyclic.\n";

  // you can run a topological sort on a cyclic graph, but
  // it doesn't necessarily have any meaning
  l = graph.TopologicalSortNodes();
  List_ForEach_Type( l, dg_node, node ) {
    cout << node->GetNum() << ", ";
    }List_End_ForEach
  cout << endl;

  graph.Print();
  return 0;
  }
