#ifndef DLINK_H
#define DLINK_H

//////////////////////////////////////////////////////
//
// dlink.h
// Class of Double link list.
//
//////////////////////////////////////////////////////

#include "sticky.h"

class DoubleLink : public Sticky {
protected:

  Object* data;
  
public:
  
  DoubleLink( Object *o) { data =  o; prev=next=0;}
  DoubleLink( Object &o) { data = &o; prev=next=0;}
  DoubleLink()           { data =  0; prev=next=0; }
 ~DoubleLink() {;}

  void    Data(Object* o) { data = o; }
  Object* Data()          { return data;}
  Object* GetData()       { return data;}

  virtual integer isa() { return DOUBLELINK;}
  virtual void    Print ( ostream& out = cout ) {
    if ( data )
      out << data;
    if ( next)
      next->PrintList(out);
  }
};

inline ostream& operator << (ostream &out, const DoubleLink& f)
{ f.Print(out); return out; }

inline ostream& operator << (ostream &out, const DoubleLink* f)
{ out << "(ptr->)"; f->Print(out); return out; }

#endif // DLINK_H

