#ifndef HASH_TABLE_H
#define HASH_TABLE_H

#include "object.h"
#include "list.h"
#include "compable.h"
#include "hashbase.h"

class HashObject : public Object {
   Object *data;
   Comparable *key;
 public:
   static int hashObjectCount;

   HashObject(Object *d,Comparable *k);
   ~HashObject();
   Object *Data() { return data;};
   Comparable *Key() { return key; };
};

class HashTable : public HashExact {
   List *buckets;
   integer bucketCount;
   integer maxDepth;
   
   integer rehashCount;
   virtual boolean Add( Object& o, Comparable *k );
   virtual void Overwrite( Object &o, Comparable *k ) {Add( o,k);}
   virtual Object* Find( Comparable *k );

   void Add (HashObject *o);
 public:

   List *Bucket(int i) { return &buckets[i];}
   int BucketCount() { return bucketCount; }

   HashTable( boolean del_data=FALSE, boolean del_key=FALSE);
   HashTable( integer size, boolean del_data=FALSE, boolean del_key=FALSE);
   ~HashTable();

   virtual boolean Remove(Comparable *key);

   void Rehash();
   virtual void Clear();
   virtual void PrintStats(ostream &out = cout);

   virtual void Print(ostream &out = cout) { PrintStats( out ); }
   virtual void Dump( ostream &out = cout );
};

#define HashTable_ForEach_Type(table,type,key,ob) \
{ for (int __hashTableIterator = 0; \
       __hashTableIterator < (table)->BucketCount(); \
       __hashTableIterator++) { \
   List_ForEach_Type(*(table)->Bucket(__hashTableIterator),HashObject,ob2) { \
      type *ob = (type *)ob2->Data(); \
      Comparable *key = ob2->Key(); {

#define HashTable_End_ForEach  } } List_End_ForEach }}

#endif
