#ifndef LEX_H
#define LEX_H

////////////////////////////////////////////////////////////////////////////
//
//  lex.h : a class to interface to lex or flex, calls yylex
//  Andrew Seawright
//  
////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include "strobj.h"
//#include "/usr/gnu/include/FlexLexer.h"


//class Lex : public Object, public FlexLexer {
class Lex : public Object {

  char        *filename;
  boolean      unget;

public:

  integer      linenum;   // these public so lex and flex can get to them 
  integer      token;
  char        *id;
  integer      val;
  double       real;

  Lex ();                   // setup input as stdin
  Lex (char *);             // open file and setup as input 
 ~Lex ();                   // destructor
  void Rewind();            // reanalyze the input file (can not be stdin)
  void Restart(char *fn);   // analyze a new file
  int  Get();               // get a token 
  void unGet();             // put back one token - only use once at a time
  void error(char *);       // output an error message
  void LineNumCorrection(); // correct line number counter (actions)
  int  Seek( integer t_id); // get tokens until token id matches arg t_id

  virtual    int isa() {return LEX;}
  StringObj* String() { return new StringObj( id, FALSE);}
       
};


inline int
Lex::Seek( integer t_id) {
  while ( t_id != Get());
  return token;
}

extern Lex *Lexthis;

#endif
