
#include "list.h"
#include "intobj.h"

void main( ) {
  List l1, *l2 = new List;

  for( int i=0 ; i<20 ; i++ ) {
    l1.Add( new IntObj(i) );
    l2->Append( new IntObj(i) );
    }
  
  IntObj *I = new IntObj( 666 );
  l1.Add( I );
  l2->Add( I );
  List *l3 = new List(*l2);
  l3->AppendUnique( I );
  ASSERT( l2->Count() == l3->Count(), "AppendUnique failed.");
  l3->Union( &l1 );
  ASSERT( l3->Count() == 41, "Union failed" );

  List l4;
  l4.TransferAppend( l3 );
  ASSERT( l4.Count() == 41 && l3->Count()==0, "TransferAppend failed" );

  ASSERT( l4.IdentityNum( I ) == 0, "IdentityNum failed" );
  l4.Remove( I );
  ASSERT( l4.Count() == 40, "Remove failed" );
  l4.Clear();
  ASSERT( l4.Count() == 0, "Clear failed" );

  Comparable *c = l2->GetMember( new IntObj( 666 ) );
  ASSERT( c == I, "GetMember Failed");

  ASSERT( l1.Member( I ), "Member failed");
  l1.ListPrint( cout, "," );
  cout << endl;
  l2->ListPrint( cout, "," );
  cout << endl;

  boolean found;
  List_iterator li2( l2 );
  while( !li2.end() ) {
    IntObj *io;
    found = FALSE;
    List_ForEach_Type( l1, IntObj, i ) {
      io = (IntObj*)li2.item();
      if( *io == *i ) {
	found = TRUE;
	break;
	}
      }List_End_ForEach
    ASSERT( found, "list iterator failed" );
    io = (IntObj*)li2.Remove();
    if( io->val != 666 ) {
      *io=*io + 100;
      li2.Insert( io );
      li2++;
      }
    }
  l2->ListPrint( cout, "," );
  l2->CleanOut();
  l1.Remove( I );
  l1.CleanOut();
  delete l2;
  // make sure the compiler doesn't delete I until the very end!
  cout << *I << "\nOK!" << endl;
  }
