#ifndef _RefComp_h
#define _RefComp_h 1

#include <iostream.h>
#include "compable.h"

#ifndef INT_PRIME
#define INT_PRIME 7919
#endif

/////////////////////////////////////////////////////////////////////////////
//
// RefComp is derived from Comparable class, and allows any Object to
// be given an arbitrary value with which it can be sorted. The object
// is Comparable by Reference to the key assigned to it.

class RefComp : public Comparable {

public:

  Object        *data;
  integer        key;

  RefComp( void)                        { key = 0; data = 0; }
  RefComp( Object* d, integer k)        { key = k; data = d; }
 ~RefComp( )                            {;}

  void Clear()                          { delete data; }

  virtual integer isa() { return REFCOMP;}
  virtual Object* Copy(){ return new RefComp( data, key );}

  virtual integer Compare( Comparable* c) {
    if (c->isa() != REFCOMP) FATAL("expecting RefComp");
    if( ((RefComp*)c)->data->isa() != data->isa() )		// this is optional--
      FATAL("Comparing two RefComps with different data types");// might not want to
								// check for this
    integer res = key - ((RefComp*) c)->key;
    if( res == 0 )
      return ((integer) data - (integer) ((RefComp*) c)->data);
    else
      return res;
  }

  virtual uinteger Hash( uinteger i=(integer)data) {
    return (uinteger) ((key+i)^0x5ab)%INT_PRIME;}
  virtual void Print( ostream& out = cout) { out << key << ", data = " << data;}
};


#endif
