#include "object.h"
#include "stddefs.h"



//////////////////////////////////////////////////////
//
// sticky.h
// Class of Double link list.
//
//////////////////////////////////////////////////////

class Sticky : public Object {
protected:

  Sticky* prev;
  Sticky* next;
    
public:
  
  Sticky() { prev=next=0; }
  ~Sticky() {Remove();}

  Sticky* Next() { return next;}
  Sticky* Prev() { return prev;}

  void Add(Sticky* E);          // Add object E in front of the object
  void Append(Sticky* E);       // Append object E behind the object
  void AddList(Sticky* E);      // Add list E in front of the object
  void AppendList(Sticky* E);   // Append list E behind the object
  void AddTo(Sticky* E);        // Add the object in front of object E
  void AppendTo(Sticky* E);     // Append object behind object E
  void AddListTo(Sticky* E);    // Add object list in front of object E
  void AppendListTo(Sticky* E); // Append object list behind object E
  void Remove();                // Remove object from list
  void RemoveList();            // Remove object list from link

  boolean Member(Sticky* E); // Search to see if E is a member
  Sticky* EndOfList();       // Returns the end of list
 
  void    Add(Sticky& E)          { Add( &E);}
  void    Append(Sticky& E)       { Append( &E);}
  void    AddList(Sticky& E)      { AddList( &E);}
  void    AppendList(Sticky& E)   { AppendList( &E);}
  void    AddTo(Sticky& E)        { AddTo( &E);}
  void    AppendTo(Sticky& E)     { AppendTo( &E);}
  void    AddListTo(Sticky& E)    { AddListTo( &E);}
  void    AppendListTo(Sticky& E) { AppendListTo( &E);}
  boolean Member(Sticky& E)       { return Member( &E);}

  virtual integer isa()      { return STICKY;}
  virtual boolean isSticky() { return TRUE;}
  virtual void PrintList ( ostream& out = cout );
};



