# wish file for bdd manipulation

set NODE_WIDTH 40
set NODE_HEIGHT 25
set NODE_OUTLINE black
set CANVAS_WIDTH 400
set current ""
set startx 0
set starty 0

proc gotobdd { n } {
  global NODE_OUTLINE

  for { set i 0 } { $i < 5 } { incr i } {
    .bddnodes itemconfigure $n -fill red
    after 200
    update
    .bddnodes itemconfigure $n -fill white
    after 200
    update
    }
  }


canvas .bddnodes -width $CANVAS_WIDTH
pack .bddnodes
focus .bddnodes

proc drawnode { bdd x y } {
  set n [ .bddnodes find withtag n$bdd ]
  if { $n != "" } {
    gotobdd $n
    return
    }
  makenode $bdd $x $y
  }

proc thent { bdd x y t } {
  global NODE_WIDTH NODE_HEIGHT
  set x1 [ expr $x + $NODE_WIDTH / 2 - 10 ]
  set y1 [ expr $y + $NODE_HEIGHT + 5 ]
  .bddnodes create text $x1 $y1 -text $t -tag n$bdd
  }

proc elset { bdd x y t } {
  global NODE_WIDTH NODE_HEIGHT
  set x1 [ expr $x + $NODE_WIDTH / 2 + 10 ]
  set y1 [ expr $y + $NODE_HEIGHT + 5]
  .bddnodes create text $x1 $y1 -text $t -tag n$bdd
  }


proc makenode { bdd x y } {
  global NODE_WIDTH NODE_HEIGHT NODE_OUTLINE CANVAS_WIDTH
  global one zero current startx starty
  set x1 $x
  set y1 $y
  set x2 [expr $x + $NODE_WIDTH]
  set y2 [expr $y + $NODE_HEIGHT]
  while { [.bddnodes find overlapping $x1 $y1 $x2 $y2 ] != "" } {
    incr x1 $NODE_WIDTH
    incr x2 $NODE_WIDTH
    if { $x2 > $CANVAS_WIDTH } {
      set x1 $x
      set x2 [expr $x + $NODE_WIDTH]
      incr y1 $NODE_HEIGHT
      incr y2 $NODE_HEIGHT
      }
    }
  set node [.bddnodes create oval $x1 $y1 $x2 $y2 -outline $NODE_OUTLINE -tag n$bdd -fill white ]
  set textx [ expr ( $x1 + $x2 ) / 2 ]
  set texty [ expr ( $y1 + $y2 ) / 2 ]
  .bddnodes create text $textx $texty -text [ index $bdd ] -tag n$bdd
  .bddnodes bind $node <1> "set current \[ .bddnodes find withtag n$bdd \]"

  set t [thenptr $bdd]
  if { $t == $one } {
    thent $bdd $x1 $y1 T
  } else {
    if { $t == $zero } {
      thent $bdd $x1 $y1 F
    } else {
      set tx1 [ expr ( $x1 + $x2 ) / 2 - 7]
      set tx2 [ expr $tx1 + 5 ]
      set ty1 [ expr $y2 ]
      set ty2 [ expr $ty1 + 5 ]
      set a [ .bddnodes create oval $tx1 $ty1 $tx2 $ty2 -outline $NODE_OUTLINE -tag n$bdd ]
      .bddnodes bind $a <1> "drawnode $t $x $ty2"
      }
    }

  set e [elseptr $bdd]
  if { $e == $one } {
    elset $bdd $x1 $y1 T
  } else {
    if { $e == $zero } {
      elset $bdd $x1 $y1 F
    } else {
      set ex1 [ expr ( $x1 + $x2 ) / 2 + 2]
      set ex2 [ expr $ex1 + 5 ]
      set ey1 [ expr $y2 ]
      set ey2 [ expr $ey1 + 5 ]
      set a [ .bddnodes create oval $ex1 $ey1 $ex2 $ey2 -outline $NODE_OUTLINE -tag n$bdd ]
      .bddnodes bind $a <1> "drawnode $e $x $ty2"
      }
    }


  }
bind .bddnodes <1> "set startx %x; set starty %y"
bind .bddnodes <ButtonRelease-1> "set current \"\" "
bind .bddnodes <Motion> "
  set diffx \[ expr %x - \$startx \]
  set diffy \[ expr %y - \$starty \]
  foreach i \$current \{ .bddnodes move \$i \$diffx \$diffy \}
  set startx %x
  set starty %y "
