
proc update_memgroup {} {
  global num_malloced num_inuse num_free num_big malloc_count alloc_count
  global updates
  .nmv configure -textvariable num_malloced
  .niv configure -textvariable num_inuse
  .nfv configure -textvariable num_free
  .nbv configure -textvariable num_big
  .mcv configure -textvariable malloc_count
  .acv configure -textvariable alloc_count
  .bddfree configure -textvariable used(20)
  .bddfree configure -textvariable used(20)
  }

proc auto_update_memgroup_run { time } {
  global auto_update_on
  while { $auto_update_on } {
    after $time
    update
    update idletasks
    update_memgroup
    }
  }

proc auto_update_memgroup { } {
  global update_time auto_update_on
  if { $auto_update_on == 0 } {
    .autob configure -text "STOP update every"
    set time [ expr $update_time * 1000 ]
    set auto_update_on 1
    auto_update_memgroup_run $time
    } else {
    .autob configure -text "START update every"
    set auto_update_on 0
    }
  }

proc init_memgroup { new_window } {
  global num_malloced num_inuse num_free num_big malloc_count alloc_count
  global update_time auto_update_on
  set update_time 1
  set auto_update_on 0

  if { $new_window == "no" } {
    frame .top
    } else {
    toplevel .top }
  frame .nm
  frame .ni
  frame .nf
  frame .nb
  frame .mc
  frame .ac
  frame .auto
  label .nml -text "Total bytes: " -width 17
  label .nmv -textvariable num_malloced
  pack .nml .nmv -side left -in .nm
  label .nil -text "bytes inuse: " -width 17
  label .niv -textvariable num_inuse
  pack .nil .niv -side left -in .ni
  label .nfl -text "bytes free: " -width 17
  label .nfv -textvariable num_free
  pack .nfl .nfv -side left -in .nf
  label .nbl -text "big mallocs: " -width 17
  label .nbv -textvariable num_big
  pack .nbl .nbv -side left -in .nb
  label .mcl -text "system mallocs:" -width 17
  label .mcv -textvariable malloc_count
  pack .mcl .mcv -side left -in .mc
  label .acl -text "memgroup mallocs:" -width 17
  label .acv -textvariable alloc_count
  pack .acl .acv -side left -in .ac
  button .update -text Update -command update_memgroup
  button .autob -text "START update every" -command auto_update_memgroup
  set update_time 10
  entry .autot -textvariable update_time -width 5
  label .autounit -text "seconds"
  pack .autot .autounit -side left -in .auto
  pack .nm .ni .nf .nb .mc .ac .update .autob .auto -side top -in .top
  frame .bddu
  label .bddusedl -text "20 byte chunks in use:"
  label .bddused -textvariable used(20)
  frame .bddf
  label .bddfreel -text "20 byte chunks free:"
  label .bddfree -textvariable used(20)
  pack .bddusedl .bddused -side left -in .bddu
  pack .bddfreel .bddfree -side left -in .bddf
  pack .bddu .bddf -side top -in .top
  pack .top
  }

