#include <stdio.h>
#include <stdlib.h>
#include <thread.h>

#include "tcl.h"
#include "tk.h"

/* update every 50 ms, if possible */
#define TK_UPDATE "update;after 50"

void *Tcl_UpdateLoop( void* arg ) {
  Tcl_Interp *interp = (Tcl_Interp*) arg;
  while(1) {
    Tcl_Eval( interp, TK_UPDATE );
    }
  return NULL;
  }

main( int argc, char **argv ) {
  /* thread stuff */
  thread_t tkid;
  int flags=0, result;

  /* extra stuff  (remove it!) */
  int i,j;
  char temp[20];

  Tcl_Interp *interp = Tcl_CreateInterp();

  if (Tcl_Init(interp) == TCL_ERROR) {
    fprintf(stderr,"Tcl initialization failed!\n");
    exit(1);
    }
  if (Tk_Init(interp) == TCL_ERROR) {
    fprintf(stderr,"Tk Initialization failed!\n");
    exit(1);
    }

  if (Tcl_EvalFile(interp, ".tkrc")==TCL_ERROR) {
    if (*interp->result !=0)
      fprintf(stderr,"%s\n", interp->result);
    fprintf(stderr,"Tcl/Tk script could not be read\n");
    exit(1);
  }
  
  if (*interp->result !=0)
    fprintf(stderr, "%s\n", interp->result);

  /* wait for the window to come up */
  Tcl_Eval( interp, "update" );

  /* the tk windows will not respond unless you periodically *
   * call the tcl command update idletasks                   */
  thr_setconcurrency(2);
  result = thr_create(NULL, 0, Tcl_UpdateLoop, (void*)interp, flags, &tkid);

  /* run your program here  (instead of the for loop)*/

  for( i=0,j=0 ; i<10000000 ; i++ ) {
    if( i%1000000 == 0 ) {
      fprintf(stderr,".");
      sprintf(temp,
	      "button .b%d -command \"puts %d\" -text \"new button\";pack .b%d",
	      j, j, j++);
      Tcl_Eval( interp, temp );
      }
    }
  fprintf(stderr, "\n");


  exit(0);
}

