#ifndef UNSIGNEDOBJ_H      
#define UNSIGNEDOBJ_H

#include <iostream.h>
#include "compable.h"

#define INT_PRIME 7919

class UnsignedObj: public Comparable {
public:
  unsigned val;

  UnsignedObj( void)       { val = 0;}
  UnsignedObj( unsigned v) { val = v;}

  unsigned operator=( unsigned i) { val = i; return i;}
  operator unsigned()   { return val;}

  virtual integer isa() { return UNSIGN_OBJ;}
  virtual Object* Copy(){ return new UnsignedObj( val);}   

  virtual integer Compare( Comparable* c) {
    ASSERT (c->isa() == UNSIGN_OBJ, "expecting UnsignedObj");
    return val - ((UnsignedObj*) c)->val;
  }

  virtual uinteger Hash( uinteger i=0) {
    return (uinteger) ((val+i)^0x5ab)%INT_PRIME;}
  virtual void Print( ostream& out = cout) const { out << val;}
  virtual void Scan ( istream&  in = cin ){ in  >> val;}
};

#endif // UNSIGNEDOBJ_H      

